/* $Id: interface.c,v 1.1.1.1 2004/10/11 17:35:28 mjhammel Exp $ */

/*========================================================================
 *  Copyright (c) Michael J. Hammel 1995-2002
 *========================================================================
 *              FILE NAME: interface.c
 *            DESCRIPTION: XNotesPlus Installer
 *      DEFINED CONSTANTS: 
 *       TYPE DEFINITIONS: 
 *      MACRO DEFINITIONS: 
 *       GLOBAL VARIABLES: 
 *       PUBLIC FUNCTIONS: 
 *      PRIVATE FUNCTIONS: 
 *  SOFTWARE DEPENDENCIES: 
 *  HARDWARE DEPENDENCIES: 
 *                  NOTES: 
 *
 * SPECIAL CONSIDERATIONS:
 * Set your tabstops to 3 to make the code more readable.
 *
 *========================================================================
 *
 * MODIFICATION HISTORY:
 * $Log: interface.c,v $
 * Revision 1.1.1.1  2004/10/11 17:35:28  mjhammel
 * Initial import
 *
 * Revision 1.4  2004/02/23 04:36:01  mjhammel
 * Calendar complete for beta 1.
 * Initial documentation updates for 3.6.
 * Fixed bug in FindText.c - accept button should be "gshell.search", not
 * "gshell.accept".
 *
 * Revision 1.3  2004/02/18 04:07:18  mjhammel
 * Applied fixes from Steve Bankowitz (Steven.Bankowitz@Sun.COM)
 *
 * Revision 1.2  2002/02/18 21:49:15  mjhammel
 * First pass at online help
 *
 *
 *
 *========================================================================*/
#define XP_INTERFACE_C


#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "XNotesPlus.h"

/* Globals */
extern int	themeid;

GtkWidget *gtkrc_field;
GtkWidget *data_directory_field;
GtkWidget *xnotes_field;
GtkWidget *tooltips_state;
GtkWidget *no_notice;
GtkWidget *no_audio;
GtkWidget *spell_checker;
GtkWidget *no_alarms;
GtkWidget *save_interval;
GtkWidget *cal_field;
GtkWidget *spell_field;
GtkWidget *printer_field;
GtkWidget *email_field;
GtkWidget *audio_field;
GtkWidget *appearance_field;
GtkWidget *status_update_bar;
GtkWidget *save_on_exit;
GtkWidget *auto_save;
GtkWidget *email_addr_field;
GtkWidget *browser_field;

GtkWidget*
create_window1 (void)
{
  GtkWidget *window1;
  GtkWidget *notebook;
  GtkWidget *label25;
  GtkWidget *label26;
  GtkWidget *hbox1;
  GtkWidget *pixmap1;
  GtkWidget *vbox2;
  GtkWidget *vbox3;
  GtkWidget *frame1;
  GtkWidget *table1;
  GtkWidget *label4;
  GtkWidget *label5;
  GtkWidget *frame3;
  GtkWidget *vbox5;
  GtkWidget *vbox5b;
  GtkWidget *table2;
  GtkWidget *table3;
  GtkWidget *cal_cmd;
  GtkWidget *spell_cmd;
  GtkWidget *printer_cmd;
  GtkWidget *email_cmd;
  GtkWidget *email_addr;
  GtkWidget *audio_cmd;
  GtkWidget *browser_cmd;
  GtkWidget *label6;
  GtkWidget *label7;
  GtkWidget *auto_save_interval;
  GtkWidget *appearance_field_menu;
  GtkWidget *glade_menuitem;
  GtkWidget *frame2;
  GtkWidget *vbox6;
  GtkWidget *hbuttonbox1;
  GtkWidget *install_button;
  GtkWidget *quit_button;
  GtkWidget *layout;
  GtkTooltips *tooltips;

	char	*datadir;
	int	index;
	int	count, interval;

  tooltips = gtk_tooltips_new ();

  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (window1, "window1");
  gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), "XNotesPlus Installer");

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox1, "hbox1");
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (window1), hbox1);



 /*
  * Splash image.
  */
  pixmap1 = create_pixmap (window1, "xnotes-splash-v3.4.xpm");
  gtk_widget_set_name (pixmap1, "pixmap1");
  gtk_widget_ref (pixmap1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "pixmap1", pixmap1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (hbox1), pixmap1, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (pixmap1), 0, 0);



  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox2, "vbox2");
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox2, TRUE, TRUE, 3);
  gtk_widget_set_usize (vbox2, 350, -2);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox3, "vbox3");
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (vbox2), vbox3, FALSE, TRUE, 0);


 /*
  * Installation directories.
  */
  frame1 = gtk_frame_new ("Installation Directories");
  gtk_widget_set_name (frame1, "frame1");
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox3), frame1, FALSE, TRUE, 2);
  gtk_frame_set_shadow_type (GTK_FRAME (frame1), GTK_SHADOW_ETCHED_OUT);

  table1 = gtk_table_new (2, 2, FALSE);
  gtk_widget_set_name (table1, "table1");
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (frame1), table1);

  label4 = gtk_label_new ("Data Directory");
  gtk_widget_set_name (label4, "label4");
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_table_attach (GTK_TABLE (table1), label4, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label4), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label4), 5, 0);

  label5 = gtk_label_new ("XNotes+ Program Directory");
  gtk_widget_set_name (label5, "label5");
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_table_attach (GTK_TABLE (table1), label5, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label5), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label5), 5, 0);

  data_directory_field = gtk_entry_new ();
  gtk_widget_set_name (data_directory_field, "data_directory_field");
  gtk_widget_ref (data_directory_field);
  gtk_object_set_data_full (GTK_OBJECT (window1), "data_directory_field", data_directory_field,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (data_directory_field);
  gtk_table_attach (GTK_TABLE (table1), data_directory_field, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, data_directory_field, "Where should we install our data files?", NULL);

	datadir = (char *)malloc(strlen(getenv("HOME")) +strlen(DefaultNoteDir) +2);
	sprintf(datadir,"%s/%s", getenv("HOME"), DefaultNoteDir);
	gtk_entry_set_text(GTK_ENTRY(data_directory_field), datadir);
	free(datadir);

  xnotes_field = gtk_entry_new ();
  gtk_widget_set_name (xnotes_field, "xnotes_field");
  gtk_widget_ref (xnotes_field);
  gtk_object_set_data_full (GTK_OBJECT (window1), "xnotes_field", xnotes_field,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (xnotes_field);
  gtk_table_attach (GTK_TABLE (table1), xnotes_field, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, xnotes_field, "Where should we install the xnotes+ program?", NULL);

	datadir = (char *)malloc(strlen(getenv("HOME")) +strlen("bin") +2);
	sprintf(datadir,"%s/%s", getenv("HOME"), "bin");
	gtk_entry_set_text(GTK_ENTRY(xnotes_field), datadir);
	free(datadir);


 /*
  * Installation options.
  */
  frame3 = gtk_frame_new ("Installation Options");
  gtk_widget_set_name (frame3, "frame3");
  gtk_widget_ref (frame3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "frame3", frame3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (vbox2), frame3, TRUE, TRUE, 2);

  notebook = gtk_notebook_new();
  gtk_widget_show(notebook);
  gtk_container_add (GTK_CONTAINER (frame3), notebook);
  gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook), GTK_POS_TOP);
  gtk_notebook_set_tab_hborder (GTK_NOTEBOOK (notebook), 4);
  gtk_notebook_set_tab_vborder (GTK_NOTEBOOK (notebook), 6);

  label25 = gtk_label_new ("Enable/Disable");
  gtk_widget_show (label25);

  label26 = gtk_label_new ("Files and External Programs");
  gtk_widget_show (label26);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox5, "vbox5");
  gtk_widget_show (vbox5);

  vbox5b = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox5b, "vbox5b");
  gtk_widget_show (vbox5b);

  gtk_notebook_append_page(GTK_NOTEBOOK (notebook), 
     GTK_WIDGET(vbox5), GTK_WIDGET(label25));
  gtk_notebook_append_page(GTK_NOTEBOOK (notebook), 
     GTK_WIDGET(vbox5b), GTK_WIDGET(label26));

  /* Display Options table */
  layout = gtk_layout_new(NULL, NULL);
  gtk_widget_show (layout);
  gtk_box_pack_start (GTK_BOX (vbox5), layout, TRUE, TRUE, 0);

  table2 = gtk_table_new (5, 2, FALSE);
  gtk_widget_set_name (table2, "table2");
  gtk_widget_ref (table2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "table2", table2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table2);
  gtk_layout_put(GTK_LAYOUT(layout), GTK_WIDGET(table2), 10, 25);

  /* External Programs table */
  table3 = gtk_table_new (11, 2, FALSE);
  gtk_widget_set_name (table3, "table3");
  gtk_widget_ref (table3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "table3", table3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table3);
  gtk_box_pack_start (GTK_BOX (vbox5b), table3, TRUE, TRUE, 0);


 /*
  * Display options.
  */
  label7 = gtk_label_new ("Appearance");
  gtk_widget_set_name (label7, "label7");
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_table_attach (GTK_TABLE (table2), label7, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label7), 0, 0.5);

  appearance_field = gtk_option_menu_new ();
  gtk_widget_set_name (appearance_field, "appearance_field");
  gtk_widget_ref (appearance_field);
  gtk_object_set_data_full (GTK_OBJECT (window1), "appearance_field", appearance_field,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (appearance_field);
  gtk_table_attach (GTK_TABLE (table2), appearance_field, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, appearance_field, "First two choices select prebuilt themes.  Last option allows choosing an external theme.", NULL);

  appearance_field_menu = gtk_menu_new ();
  themeid = index = 0;
  glade_menuitem = gtk_menu_item_new_with_label ("Use Extended Theme");
  gtk_widget_show (glade_menuitem);
  gtk_signal_connect_object(GTK_OBJECT(glade_menuitem), "activate",
         GTK_SIGNAL_FUNC(XPThemeSetCB), (gpointer) index);
  gtk_menu_append (GTK_MENU (appearance_field_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("Use Standard Theme");
  gtk_widget_show (glade_menuitem);
  index++;
  gtk_signal_connect_object(GTK_OBJECT(glade_menuitem), "activate",
         GTK_SIGNAL_FUNC(XPThemeSetCB), (gpointer) index);
  gtk_menu_append (GTK_MENU (appearance_field_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("Use another theme");
  gtk_widget_show (glade_menuitem);
  index++;
  gtk_signal_connect_object(GTK_OBJECT(glade_menuitem), "activate",
         GTK_SIGNAL_FUNC(XPThemeSetCB), (gpointer) index);
  gtk_menu_append (GTK_MENU (appearance_field_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (appearance_field), appearance_field_menu);

  save_on_exit = gtk_check_button_new_with_label ("Save On Exit");
  gtk_widget_set_name (save_on_exit, "save_on_exit");
  gtk_widget_ref (save_on_exit);
  gtk_object_set_data_full (GTK_OBJECT (window1), "save_on_exit", save_on_exit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_on_exit);
  gtk_table_attach (GTK_TABLE (table2), save_on_exit, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, save_on_exit, "If selected, modified xnotes are saved when the user quits the program.", NULL);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (save_on_exit), TRUE);

  auto_save = gtk_check_button_new_with_label ("Auto Save XNotes");
  gtk_widget_set_name (auto_save, "auto_save");
  gtk_widget_ref (auto_save);
  gtk_object_set_data_full (GTK_OBJECT (window1), "auto_save", auto_save,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (auto_save);
  gtk_table_attach (GTK_TABLE (table2), auto_save, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, auto_save, "If selected, xnotes are saved automatically using the Auto Save interval.", NULL);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (auto_save), TRUE);

  tooltips_state = gtk_check_button_new_with_label ("Use Tooltips");
  gtk_widget_set_name (tooltips_state, "tooltips_state");
  gtk_widget_ref (tooltips_state);
  gtk_object_set_data_full (GTK_OBJECT (window1), "tooltips_state", tooltips_state,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tooltips_state);
  gtk_table_attach (GTK_TABLE (table2), tooltips_state, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, tooltips_state, "If selected, Tooltips will be enabled by default.", NULL);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (tooltips_state), TRUE);

  no_notice = gtk_check_button_new_with_label ("Disable Features Notification");
  gtk_widget_set_name (no_notice, "no_notice");
  gtk_widget_ref (no_notice);
  gtk_object_set_data_full (GTK_OBJECT (window1), "no_notice", no_notice,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (no_notice);
  gtk_table_attach (GTK_TABLE (table2), no_notice, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, no_notice, "If selected, the pop up notice specifying which features have been disabled will not be shown.", NULL);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (no_notice), TRUE);

  no_audio = gtk_check_button_new_with_label ("Disable Audio");
  gtk_widget_set_name (no_audio, "no_audio");
  gtk_widget_ref (no_audio);
  gtk_object_set_data_full (GTK_OBJECT (window1), "no_audio", no_audio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (no_audio);
  gtk_table_attach (GTK_TABLE (table2), no_audio, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, no_audio, "If selected, audio features will be disabled by default.", NULL);

  no_alarms = gtk_check_button_new_with_label ("Disable Alarms");
  gtk_widget_set_name (no_alarms, "no_alarms");
  gtk_widget_ref (no_alarms);
  gtk_object_set_data_full (GTK_OBJECT (window1), "no_alarms", no_alarms,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (no_alarms);
  gtk_table_attach (GTK_TABLE (table2), no_alarms, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, no_alarms, "If selected, the alarm features for xnotes will be disabled by default.", NULL);


 /*
  *  External Programs.
  */
  label6 = gtk_label_new ("GTK rc file");
  gtk_widget_set_name (label6, "label6");
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_table_attach (GTK_TABLE (table3), label6, 0, 1, 0, 1, 
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label6), 0, 0.5);

  gtkrc_field = gtk_entry_new ();
  gtk_widget_set_name (gtkrc_field, "gtkrc_field");
  gtk_widget_ref (gtkrc_field);
  gtk_object_set_data_full (GTK_OBJECT (window1), "gtkrc_field", gtkrc_field,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (gtkrc_field);
  gtk_table_attach (GTK_TABLE (table3), gtkrc_field, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, gtkrc_field, "If Graphics Muse themes are not chosen, specify the name of the GTKRC file to use for XNotesPlus.", NULL);

	datadir = (char *)malloc(strlen(getenv("HOME")) +
		strlen(DefaultNoteDir) + strlen(DefaultGtkRC) + 3);
	sprintf(datadir,"%s/%s/%s", getenv("HOME"), DefaultNoteDir, DefaultGtkRC);
	gtk_entry_set_text(GTK_ENTRY(gtkrc_field), datadir);
	free(datadir);

	/* By default, the user doesn't need to set a GtkRC file. */
	gtk_widget_set_sensitive(gtkrc_field, FALSE);

  auto_save_interval = gtk_label_new ("Auto Save Interval");
  gtk_widget_set_name (auto_save_interval, "auto_save_interval");
  gtk_widget_ref (auto_save_interval);
  gtk_object_set_data_full (GTK_OBJECT (window1), "auto_save_interval", auto_save_interval,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (auto_save_interval);
  gtk_table_attach (GTK_TABLE (table3), auto_save_interval, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (auto_save_interval), 0, 0.5);

  save_interval = gtk_entry_new ();
  gtk_widget_set_name (save_interval, "save_interval");
  gtk_widget_ref (save_interval);
  gtk_object_set_data_full (GTK_OBJECT (window1), "save_interval", save_interval,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_interval);
  gtk_table_attach (GTK_TABLE (table3), save_interval, 1, 2, 1, 2, 
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, save_interval, "How long between automatic saving of notes (in seconds)?", NULL);

	interval = DefaultInterval;
	count = 1;
	while ( interval > 9 ) 
	{
		count++;
		interval = (int)(interval / 10);
	}
	datadir = (char *)malloc(count+1);
	sprintf(datadir,"%d", DefaultInterval);
	gtk_entry_set_text(GTK_ENTRY(save_interval), datadir);
	free(datadir);

  spell_cmd = gtk_label_new ("Spell Check program");
  gtk_widget_set_name (spell_cmd, "spell_cmd");
  gtk_widget_ref (spell_cmd);
  gtk_object_set_data_full (GTK_OBJECT (window1), "spell_cmd", spell_cmd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spell_cmd);
  gtk_table_attach (GTK_TABLE (table3), spell_cmd, 0, 1, 2, 3, 
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (spell_cmd), 0, 0.5);

  spell_field = gtk_entry_new ();
  gtk_widget_set_name (spell_field, "spell_field");
  gtk_widget_ref (spell_field);
  gtk_object_set_data_full (GTK_OBJECT (window1), "spell_field", spell_field,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spell_field);
  gtk_table_attach (GTK_TABLE (table3), spell_field, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, spell_field, 
		"What program should we use spell check an XNote?", NULL);

	datadir = (char *)malloc(strlen(DefaultSpellChecker));
	sprintf(datadir,"%s", DefaultSpellChecker);
	gtk_entry_set_text(GTK_ENTRY(spell_field), datadir);
	free(datadir);

  cal_cmd = gtk_label_new ("Calendar program");
  gtk_widget_set_name (cal_cmd, "cal_cmd");
  gtk_widget_ref (cal_cmd);
  gtk_object_set_data_full (GTK_OBJECT (window1), "cal_cmd", cal_cmd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cal_cmd);
  gtk_table_attach (GTK_TABLE (table3), cal_cmd, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (cal_cmd), 0, 0.5);

  cal_field = gtk_entry_new ();
  gtk_widget_set_name (cal_field, "cal_field");
  gtk_widget_ref (cal_field);
  gtk_object_set_data_full (GTK_OBJECT (window1), "cal_field", cal_field,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cal_field);
  gtk_table_attach (GTK_TABLE (table3), cal_field, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, cal_field, "What program should we use to insert a calendar into an XNote?", NULL);

	datadir = (char *)malloc(strlen(DefaultCalendarCmd));
	sprintf(datadir,"%s", DefaultCalendarCmd);
	gtk_entry_set_text(GTK_ENTRY(cal_field), datadir);
	free(datadir);

  printer_cmd = gtk_label_new ("Print command");
  gtk_widget_set_name (printer_cmd, "printer_cmd");
  gtk_widget_ref (printer_cmd);
  gtk_object_set_data_full (GTK_OBJECT (window1), "printer_cmd", printer_cmd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (printer_cmd);
  gtk_table_attach (GTK_TABLE (table3), printer_cmd, 0, 1, 6, 7,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (printer_cmd), 0, 0.5);

  printer_field = gtk_entry_new ();
  gtk_widget_set_name (printer_field, "printer_field");
  gtk_widget_ref (printer_field);
  gtk_object_set_data_full (GTK_OBJECT (window1), "printer_field", printer_field,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (printer_field);
  gtk_table_attach (GTK_TABLE (table3), printer_field, 1, 2, 6, 7,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, printer_field, "What is the full command to use for printing a file?  Use %s for the filename.", NULL);

	datadir = (char *)malloc(strlen(DefaultPrintCmd) + 1);
	sprintf(datadir, DefaultPrintCmd, "\%s");
	gtk_entry_set_text(GTK_ENTRY(printer_field), datadir);
	free(datadir);

  email_cmd = gtk_label_new ("Email command");
  gtk_widget_set_name (email_cmd, "email_cmd");
  gtk_widget_ref (email_cmd);
  gtk_object_set_data_full (GTK_OBJECT (window1), "email_cmd", email_cmd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (email_cmd);
  gtk_table_attach (GTK_TABLE (table3), email_cmd, 0, 1, 7, 8,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (email_cmd), 0, 0.5);

  email_field = gtk_entry_new ();
  gtk_widget_set_name (email_field, "email_field");
  gtk_widget_ref (email_field);
  gtk_object_set_data_full (GTK_OBJECT (window1), "email_field", email_field,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (email_field);
  gtk_table_attach (GTK_TABLE (table3), email_field, 1, 2, 7, 8,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, email_field, "What is the full command to use to send a mail message?  It must accept mail text as standard input.  Use %s for the subject line and for the recipient address.", NULL);

	datadir = (char *)malloc(strlen(DefaultEmailCmd) + 1);
	sprintf(datadir, DefaultEmailCmd, "\%s", "\%s");
	gtk_entry_set_text(GTK_ENTRY(email_field), datadir);
	free(datadir);

  email_addr = gtk_label_new ("Email Address");
  gtk_widget_set_name (email_addr, "email_addr");
  gtk_widget_ref (email_addr);
  gtk_object_set_data_full (GTK_OBJECT (window1), "email_addr", email_addr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (email_addr);
  gtk_table_attach (GTK_TABLE (table3), email_addr, 0, 1, 8, 9,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (email_addr), 0, 0.5);

  email_addr_field = gtk_entry_new ();
  gtk_widget_set_name (email_addr_field, "email_addr_field");
  gtk_widget_ref (email_addr_field);
  gtk_object_set_data_full (GTK_OBJECT (window1), "email_addr_field", email_addr_field,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (email_addr_field);
  gtk_table_attach (GTK_TABLE (table3), email_addr_field, 1, 2, 8, 9,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, email_addr_field, "What is the default email address to use?", NULL);

	datadir = (char *)malloc(strlen(DefaultEmailAddr) + 1);
	sprintf(datadir, "%s", DefaultEmailAddr);
	gtk_entry_set_text(GTK_ENTRY(email_addr_field), datadir);
	free(datadir);

  audio_cmd = gtk_label_new ("Audio command");
  gtk_widget_set_name (audio_cmd, "audio_cmd");
  gtk_widget_ref (audio_cmd);
  gtk_object_set_data_full (GTK_OBJECT (window1), "audio_cmd", audio_cmd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (audio_cmd);
  gtk_table_attach (GTK_TABLE (table3), audio_cmd, 0, 1, 9, 10,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (audio_cmd), 0, 0.5);

  audio_field = gtk_entry_new ();
  gtk_widget_set_name (audio_field, "audio_field");
  gtk_widget_ref (audio_field);
  gtk_object_set_data_full (GTK_OBJECT (window1), "audio_field", audio_field,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (audio_field);
  gtk_table_attach (GTK_TABLE (table3), audio_field, 1, 2, 9, 10,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, audio_field, "What is the command to use to play audio files? Use %s for the file file.", NULL);

	datadir = (char *)malloc(strlen(DefaultAudioCmd) + 1);
	sprintf(datadir, "%s", DefaultAudioCmdString);
	gtk_entry_set_text(GTK_ENTRY(audio_field), datadir);
	free(datadir);

  browser_cmd = gtk_label_new ("Help browser");
  gtk_widget_set_name (browser_cmd, "browser_cmd");
  gtk_widget_ref (browser_cmd);
  gtk_object_set_data_full (GTK_OBJECT (window1), "browser_cmd", browser_cmd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (browser_cmd);
  gtk_table_attach (GTK_TABLE (table3), browser_cmd, 0, 1, 10, 11,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (browser_cmd), 0, 0.5);

  browser_field = gtk_entry_new ();
  gtk_widget_set_name (browser_field, "browser_field");
  gtk_widget_ref (browser_field);
  gtk_object_set_data_full (GTK_OBJECT (window1), "browser_field", browser_field,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (browser_field);
  gtk_table_attach (GTK_TABLE (table3), browser_field, 1, 2, 10, 11,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, browser_field, 
	"What Web browser should be used to display HTML-based help files?", NULL);

	datadir = (char *)malloc(strlen(DefaultBrowserCmd) + 1);
	sprintf(datadir, "%s", DefaultBrowserCmd);
	gtk_entry_set_text(GTK_ENTRY(browser_field), datadir);
	free(datadir);


 /*
  * Installation status.
  */
  frame2 = gtk_frame_new ("Install Status");
  gtk_widget_set_name (frame2, "frame2");
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox2), frame2, FALSE, TRUE, 2);

  vbox6 = gtk_vbox_new (TRUE, 0);
  gtk_widget_set_name (vbox6, "vbox6");
  gtk_widget_ref (vbox6);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox6", vbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox6);
  gtk_container_add (GTK_CONTAINER (frame2), vbox6);

  status_update_bar = gtk_progress_bar_new ();
  gtk_widget_set_name (status_update_bar, "status_update_bar");
  gtk_widget_ref (status_update_bar);
  gtk_object_set_data_full (GTK_OBJECT (window1), "status_update_bar", status_update_bar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (status_update_bar);
  gtk_box_pack_start (GTK_BOX (vbox6), status_update_bar, FALSE, FALSE, 0);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_set_name (hbuttonbox1, "hbuttonbox1");
  gtk_widget_ref (hbuttonbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbuttonbox1", hbuttonbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_end (GTK_BOX (vbox2), hbuttonbox1, FALSE, FALSE, 0);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbuttonbox1), 20);
  gtk_button_box_set_child_ipadding (GTK_BUTTON_BOX (hbuttonbox1), 0, 0);

  install_button = gtk_button_new_with_label ("Install");
  gtk_widget_set_name (install_button, "install_button");
  gtk_widget_ref (install_button);
  gtk_object_set_data_full (GTK_OBJECT (window1), "install_button", install_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (install_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), install_button);
  GTK_WIDGET_SET_FLAGS (install_button, GTK_CAN_DEFAULT);

  quit_button = gtk_button_new_with_label ("Quit");
  gtk_widget_set_name (quit_button, "quit_button");
  gtk_widget_ref (quit_button);
  gtk_object_set_data_full (GTK_OBJECT (window1), "quit_button", quit_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (quit_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), quit_button);
  GTK_WIDGET_SET_FLAGS (quit_button, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (install_button), "clicked",
                      GTK_SIGNAL_FUNC (XPInstallerStart),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (quit_button), "clicked",
                      GTK_SIGNAL_FUNC (XPInstallerQuit),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (window1), "tooltips", tooltips);

  return window1;
}

