/* $Id: text.c,v 1.1 2005/06/23 21:19:58 mjhammel Exp $ */

/*========================================================================
 *  Copyright (c) Michael J. Hammel 1995-2001
 *========================================================================
 *              FILE NAME: text.c
 *            DESCRIPTION: common routines for dealing with GtkTextViews
 *      DEFINED CONSTANTS: 
 *       TYPE DEFINITIONS: 
 *      MACRO DEFINITIONS: 
 *       GLOBAL VARIABLES: 
 *       PUBLIC FUNCTIONS: XPTextErase
 *      PRIVATE FUNCTIONS: 
 *  SOFTWARE DEPENDENCIES: 
 *  HARDWARE DEPENDENCIES: 
 *                  NOTES: 
 *
 * SPECIAL CONSIDERATIONS:
 * Set your tabstops to 3 to make the code more readable.
 *
 *========================================================================
 *
 * MODIFICATION HISTORY:
 * $Log: text.c,v $
 * Revision 1.1  2005/06/23 21:19:58  mjhammel
 * Added text.c for generic GtkTextView/Buffer handling.
 *
 *========================================================================*/
#define XP_TEXT_C

/* === System Headers === */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <sys/stat.h>
#include <time.h>

#ifdef USE_DIR
#include <sys/dir.h>
#else
#include <dirent.h>
#endif

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>


/* === Project Headers === */
#include "XNotesPlus.h"
#include "debug.h"


/* === external routines === */


/* === Public routine prototypes === */


/* === Private routine prototypes === */


/* === Global Variables === */
extern GtkWidget		*toplevel;
extern AppRes			app_res;
extern StickyNote		*notes;

/* === Static Variables === */



/*========================================================================
 *	Name:			XPTextErase
 *	Prototype:	void *XPTextErase
 *					
 *	Description:
 * Clear a GtkTextBuffer 
 *
 *	Input Arguments:
 *	Output Arguments:
 *	Return Values:
 *	Global Variables:
 *	External Routines:
 *	Method:
 *	Restrictions:
 *	Notes:
 *========================================================================*/
void
XPTextErase(
	GtkTextBuffer	*text_buffer
)
{
	GtkTextIter		start_iter, end_iter;

	gtk_text_buffer_get_bounds(text_buffer ,&start_iter, &end_iter);
	gtk_text_buffer_delete(text_buffer, &start_iter, &end_iter);
}


